<?php 

namespace Opencart\Catalog\Controller\Extension\PayAnyWay\Payment;

date_default_timezone_set('Europe/Moscow');

class PayAnyWay extends \Opencart\System\Engine\Controller{
    public function index() : string{
        $this->load->language('extension/payanyway/payment/payanyway');

        $orderId = $this->session->data['order_id'];
        $orderInfo = $this->model_checkout_order->getOrder($orderId);
        $shopCfg = $this->config;
        $paymentURL = $shopCfg->get('payment_payanyway_url_payments');

        $data['action'] = $paymentURL;
        $data['actionBankCards'] = 'https://'. $paymentURL .'/assistant-builder';

        $data['button_pay'] = $this->language->get('text_paw_pay');
        $data['bank_cards'] = $shopCfg->get('payment_payanyway_bank_cards');

        $data['return_url'] = $this->url->link('checkout/success', 'language=' . $this->config->get('config_language'), true);
        $data['MNT_SUCCESS_URL'] = $this->url->link('checkout/success', 'language=' . $this->config->get('config_language'), true);
        $data['MNT_FAIL_URL'] = $this->url->link('checkout/failure', 'language=' . $this->config->get('config_language'), true);
        $data['MNT_RETURN_URL'] = $this->url->link('checkout/checkout', 'language=' . $this->config->get('config_language'), true);
        $data['MNT_ID'] = $shopCfg->get('payment_payanyway_account');
        $data['MNT_AMOUNT'] = number_format($orderInfo['total'], 2, '.', '');
        $data['MNT_TRANSACTION_ID'] = $orderId . '-' . date('YmdHis');
        $data['MNT_SUBSCRIBER_ID'] = $this->session->data['customer']['email'];
        $data['MNT_CURRENCY_CODE'] = 'RUB';
        $data['MNT_TEST_MODE'] = '0';
        $data['MNT_DESCRIPTION'] = 'Оплата по заказу №' .  $orderId;

        $data['MNT_SIGNATURE'] = md5($data['MNT_ID'] . $data['MNT_TRANSACTION_ID'] . $data['MNT_AMOUNT'] . $data['MNT_CURRENCY_CODE'] . $data['MNT_SUBSCRIBER_ID'] . $data['MNT_TEST_MODE'] . $shopCfg->get('payment_payanyway_secret'));

        return $this->load->view('extension/payanyway/catalog/payanyway', $data);
    }
}